#!/usr/bin/env ruby
$start = Time.now()
require 'rubygems'
require 'pathname'
Gem.path.push "/opt/local/lib/ruby/gems/1.8"
# needed for html
require 'cgi'
require 'stringio'
# needed for zip
require 'ftools'
require 'zip/zip'
require 'zip/zipfilesystem'
UPLOAD_DIR = "./tmp"

HTML_TEMPLATE = <<eot
<?xml version="1.0" encoding="ISO-8859-1" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
       "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<html><head><title>File Upload (Ruby)</title>
</head><body><h1>File Upload (Ruby)</h1>
<form action="" method="post" enctype="multipart/form-data">
<input type="hidden" name="action" value="upload"/>
File name: <input name="file" type="file"/><br/>
<input name="submit" type="submit"/>
</form>
</body>
</html>
eot

UPLOAD_TEMPLATE = <<eot
<?xml version="1.0" encoding="ISO-8859-1" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
       "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<html><head><title>Gallery View (Ruby)</title>
</head><body><h1>Gallery View (Ruby)</h1>
eot

HEADER = "content-type: text/html\n\n"

def error(text)
	puts HEADER
	puts "<html><body><h1>"+text+"</h1></body></html>"
	exit()
end
    
def processFile(form_field)
     fileitem = $cgi.params[form_field].first
     filepath = UPLOAD_DIR+"/"+fileitem.original_filename()
     File.open(filepath.untaint, 'w') { |file| file << fileitem.read}
     return filepath
end

def unzip(file, path)
	zipFile = Zip::ZipFile.open(file)
	zipFile.each do |single_file|
		next unless (single_file.name =~ /\/([^\/]*)$/)
		targetName = $1
		next if targetName =~ /^\./
    zipFile.extract(single_file, path+"/"+targetName) {true}
	end
end

def createThumbnails(path)
	allFiles = Dir.entries(path)
	imageFiles = allFiles.find_all{|item| item =~ /\.jpg$/ && !(item =~ /^\./) && !(item =~ /_T\.jpg$/)}
	imageFiles.each do |f|
		inputfile = path+"/"+f
 		f =~ /(.*)\.jpg$/
		outputfile = path+"/"+$1+"_T.jpg"
		cmd = "/usr/local/bin/convert -resize 100x100 "+inputfile+" "+outputfile
		File.delete(inputfile) if (!system(cmd))
	end
end
# 	
def generateWebsite(path)
 	html = UPLOAD_TEMPLATE
	allFiles = Dir.entries(path)
	imageFiles = allFiles.find_all{|item| item =~ /\.jpg$/ && !(item =~ /^\./) && !(item =~ /_T\.jpg$/)}
	imageFiles.each do |f|
 		inputfile = path+"/"+f
 		f =~ /(.*)\.jpg$/
		outputfile = path+"/"+$1+"_T.jpg"
 		html += '<div class="image"><a href="'
 		html += inputfile
 		html += '"><img src="'
 		html += outputfile
 		html += '"/></a></div>'
	end
 	html += "Store file: %f seconds<br/>" % $timeUpload
 	html += "Unzip file: %f seconds<br/>" % ($timeUnzip-$timeUpload)
	html += "Create thumbnails: %f seconds<br/>" % ($timeThumbnails-$timeUnzip)
 	html += "Overall: %f seconds<br/>" % $timeThumbnails
 	html += """</body></html>"""
	return html
end

if ARGV.length>=1
	# wir haben ein command line argument!
	puts "Command line"
	filepath = ARGV[0]
	$timeUpload = Time.now()-$start
	unzip(filepath, UPLOAD_DIR)
	$timeUnzip = Time.now()-$start
	createThumbnails(UPLOAD_DIR)
	$timeThumbnails = Time.now()-$start
	html = generateWebsite(UPLOAD_DIR)
	File.open("gallery.html", 'w') {|f| f.write(html) }
	exit()
else
	$cgi = CGI.new()  # New CGI object
	if $cgi.has_key?('file')
		filepath = processFile('file')
		$timeUpload = Time.now()-$start
		unzip(filepath, UPLOAD_DIR)
		$timeUnzip = Time.now()-$start
		createThumbnails(UPLOAD_DIR)
		$timeThumbnails = Time.now()-$start
		puts HEADER
		puts generateWebsite(UPLOAD_DIR)
		exit()
	end
		
	puts HEADER
	puts HTML_TEMPLATE
end



